using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;

namespace ColumnSets
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        GridSummaryColumnDescriptor scd1,scd2,scd3,scd4;
        GridSummaryRowDescriptor srd,srd1;

        private void Form1_Load(object sender, EventArgs e)
        {
            #region datatable
            DataTable dt = new DataTable("MyTable");

            int nCols = 4;
            int nRows = 20;
            Random r = new Random(123345345);

            for (int i = 0; i < nCols; i++)
                dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));
          

            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                    dr[j] = r.Next(5);
                 dt.Rows.Add(dr);
            }

            #endregion

            this.gridGroupingControl1.DataSource = dt;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridGroupingControl1.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;

            //create a column set descriptor
            GridColumnSetDescriptor csd = new GridColumnSetDescriptor();
            
            //add spans to it to define the cells being used for each field
            //                                                           fieldname, span range  
            GridColumnSpanDescriptor span = new GridColumnSpanDescriptor("Col0", "R0C0");
            csd.ColumnSpans.Add(span);
            
            //                                  fieldname, span range  
            span = new GridColumnSpanDescriptor("Col1", "R0C1"); 
            csd.ColumnSpans.Add(span);

            //                                  fieldname, span range  
            span = new GridColumnSpanDescriptor("Col2", "R0C2"); 
             csd.ColumnSpans.Add(span);

             //                                 fieldname, span range              
            span = new GridColumnSpanDescriptor("Col3", "R1C0:R1C2");
            
            csd.ColumnSpans.Add(span);

            //add the column set to the TableDescriptor.ColumnsSets colection.
            this.gridGroupingControl1.TableDescriptor.ColumnSets.Add(csd);

            this.gridGroupingControl1.TableDescriptor.Columns["Col3"].Appearance.AnyRecordFieldCell.BackColor = Color.LightBlue;
            
            scd1 = new GridSummaryColumnDescriptor("SumCol1", Syncfusion.Grouping.SummaryType.Int32Aggregate, "Col0", "{Sum}");
            scd2 = new GridSummaryColumnDescriptor("SumCol2", Syncfusion.Grouping.SummaryType.Int32Aggregate, "Col1", "{Sum}");
            scd3 = new GridSummaryColumnDescriptor("SumCol3", Syncfusion.Grouping.SummaryType.Int32Aggregate, "Col2", "{Sum}");
            scd4 = new GridSummaryColumnDescriptor("SumCol4", Syncfusion.Grouping.SummaryType.Int32Aggregate, "Col3", "{Sum}");

            srd = new GridSummaryRowDescriptor("SumRow1", new GridSummaryColumnDescriptor[] { scd1, scd2, scd3});
            srd1 = new GridSummaryRowDescriptor("SumRow2", scd4);
            srd1.Appearance.AnySummaryCell.BackColor = Color.Red;

            //Setting for summary row display
            this.gridGroupingControl1.TopLevelGroupOptions.ShowGroupSummaryWhenCollapsed = true;
            this.gridGroupingControl1.ChildGroupOptions.ShowGroupSummaryWhenCollapsed = true;
            this.gridGroupingControl1.TopLevelGroupOptions.SummaryRowPlacement = GridSummaryRowPlacement.BeforeDetails;
            this.gridGroupingControl1.ChildGroupOptions.SummaryRowPlacement = GridSummaryRowPlacement.BeforeDetails;

            this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(srd);
            this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(srd1);
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("Col0");
            this.gridGroupingControl1.TopLevelGroupOptions.ShowSummaries = false;

            this.gridGroupingControl1.ChildGroupOptions.CaptionText = "{Category}";
        }
    }
}